Bug 209635 - documentation for auto.master does not describe flag format
documentation for auto.master does not describe flag format
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: autofs (Show other bugs)
4.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeff Moyer
Brock Organ
http://www.redhat.com/docs/manuals/en...
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2006-10-06 11:32 EDT by Daniel Lipsitt
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version: RHBA-2007-0274
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-05-07 19:28:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
update auto.master(5) (933 bytes, patch)
2006-11-27 17:27 EST, Jeff Moyer
no flags Details | Diff
add an example, fix the mount options statement (1.21 KB, patch)
2006-11-28 16:27 EST, Jeff Moyer
no flags Details | Diff

  None (edit)
Description Daniel Lipsitt 2006-10-06 11:32:14 EDT
Description of problem:
I couldn't find documentation that describes how to format flags at the end of a
line in auto.master. The man page merely says "The third field is optional and
can contain options to+ be applied to all entries in the map." The following are
unclear:

 - should the options should be separated by whitespace or commas?
 - should each flag should be preceded by dashes or only the first (as seems to
be the case in the other auto.* files)
 - should gnu-style flags (preceded by two dashes) always use an equal sign
between the flag and its argument? Can they be mixed with single-dash args?

A more thorough example section in auto.master(5) would help clarify. For
example, which (if any) of these is correct?

/home /etc/auto.home --timeout 60 -intr
/home /etc/auto.home --timeout=60,-intr
/home /etc/auto.home --timeout=60,intr
/home /etc/auto.home -intr,timeout=60

I couldn't find an answer in either of these two pages:
http://www.redhat.com/docs/manuals/enterprise/RHEL-4-Manual/sysadmin-guide/s1-nfs-mount.html
http://www.redhat.com/docs/manuals/enterprise/RHEL-4-Manual/ref-guide/s1-nfs-client-config.html


Version-Release number of selected component (if applicable):
autofs-4.1.3-187 (RHEL 4.4)
autofs-4.1.4-5   (FC 4)
Comment 1 Daniel Lipsitt 2006-10-06 11:35:58 EDT
Also, I'm not entirely clear on what this means:

"Options are cumulative, which is a difference from the behavior of the SunOS
automounter."

Can options in auto.<something> override the options in auto.master?
Comment 2 Ian Kent 2006-10-06 12:26:03 EDT
(In reply to comment #0)
> Description of problem:
> I couldn't find documentation that describes how to format flags at the end of a
> line in auto.master. The man page merely says "The third field is optional and
> can contain options to+ be applied to all entries in the map." The following are
> unclear:

Yes it is. I don't have version 4 installed but looking at the
man source it appears lacking.

> 
>  - should the options should be separated by whitespace or commas?
>  - should each flag should be preceded by dashes or only the first (as seems to
> be the case in the other auto.* files)
>  - should gnu-style flags (preceded by two dashes) always use an equal sign
> between the flag and its argument? Can they be mixed with single-dash args?

The version 5 auto.master(5) says:

options
     Any remaining command line arguments without leading dashes
    (-) are taken as options (-o) to mount.  Arguments with leading
    dashes are considered options for the maps.

Mmm .. it doesn't say they can be seperated with spaces but they
can. How about a comment for improvement.

> 
> A more thorough example section in auto.master(5) would help clarify. For
> example, which (if any) of these is correct?
> 
> /home /etc/auto.home --timeout 60 -intr
> /home /etc/auto.home --timeout=60,-intr
> /home /etc/auto.home --timeout=60,intr

I think the intr, being an option for mount(8) should not
have a "-". So the last entry here should work and I think
either a comma or space is OK.

> /home /etc/auto.home -intr,timeout=60

Don't think this will work as the timeout option is an autofs
option and is the long for so requires a preceeding "--".

Ian
Comment 3 Ian Kent 2006-10-06 12:29:36 EDT
(In reply to comment #1)
> Also, I'm not entirely clear on what this means:
> 
> "Options are cumulative, which is a difference from the behavior of the SunOS
> automounter."
> 
> Can options in auto.<something> override the options in auto.master?

No, if mount options are given in auto.master and a map entry they are
combined at mount time. The Sun automounter will use only the mount
options in a map entry if they are given otherwise it will use mount
option given in the master map entry, if any.

Ian
Comment 4 Ian Kent 2006-10-06 12:33:14 EDT
(In reply to comment #3)
> (In reply to comment #1)
> > Also, I'm not entirely clear on what this means:
> > 
> > "Options are cumulative, which is a difference from the behavior of the SunOS
> > automounter."
> > 
> > Can options in auto.<something> override the options in auto.master?
> 
> No, if mount options are given in auto.master and a map entry they are
> combined at mount time. The Sun automounter will use only the mount
> options in a map entry if they are given otherwise it will use mount
> option given in the master map entry, if any.

But that deserves further qualification.
I believe that mount(8) will use the last occurance of a mount
option so I expect that an option present in both would end up
using the entry present in the map entry over the one given in
the master map entry.

Ian
Comment 5 Daniel Lipsitt 2006-10-06 14:09:53 EDT
(In reply to comment #4)
> (In reply to comment #3)
> > (In reply to comment #1)
> > > Also, I'm not entirely clear on what this means:
> > > 
> > > "Options are cumulative, which is a difference from the behavior of the SunOS
> > > automounter."
> > > 
> > > Can options in auto.<something> override the options in auto.master?
> > 
> > No, if mount options are given in auto.master and a map entry they are
> > combined at mount time. The Sun automounter will use only the mount
> > options in a map entry if they are given otherwise it will use mount
> > option given in the master map entry, if any.
> 
> But that deserves further qualification.
> I believe that mount(8) will use the last occurance of a mount
> option so I expect that an option present in both would end up
> using the entry present in the map entry over the one given in
> the master map entry.

That is what I meant by "override."

So, in other words, if the master has the "hard" flag and the non-master says
"soft",  it will be soft. Correct?
Comment 6 Jeff Moyer 2006-11-27 17:27:43 EST
Created attachment 142235 [details]
update auto.master(5)
Comment 7 RHEL Product and Program Management 2006-11-27 22:31:37 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 8 RHEL Product and Program Management 2006-11-27 22:31:42 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 9 RHEL Product and Program Management 2006-11-27 22:31:43 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 10 RHEL Product and Program Management 2006-11-27 22:32:01 EST
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 11 Daniel Lipsitt 2006-11-28 15:17:01 EST
The patch contradicts the text Ian quotes:

> The version 5 auto.master(5) says:
>
> options
>      Any remaining command line arguments without leading dashes
>     (-) are taken as options (-o) to mount.  Arguments with leading
>     dashes are considered options for the maps.


I also don't think it addresses all the issues. From what Ian says, it sounds
like the following statements are true. If they are, they should be included:

- Options may be separated by spaces (and/ ?) or commas.
- Options in the automounter maps can override options in the master map.

Examples would be good, too.
Comment 12 Jeff Moyer 2006-11-28 16:27:44 EST
Created attachment 142328 [details]
add an example, fix the mount options statement
Comment 16 Jeff Moyer 2007-01-05 18:44:59 EST
A fix for this issue has been built into autofs package version 4.1.3-199.
Comment 19 Red Hat Bugzilla 2007-05-07 19:28:59 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0274.html

Note You need to log in before you can comment on or make changes to this bug.